use std::collections::HashMap;

pub struct Solution;

impl Solution {
    /// This function takes a vector of integers (`nums`) and an integer (`target`) as input.
    /// It returns a vector of integers.
    ///
    /// # Arguments
    ///
    /// * `nums` - A vector of integers.
    /// * `target` - An integer that represents the target sum.
    ///
    /// # Returns
    ///
    /// This function returns a vector of integers.
    pub fn two_sum(nums: Vec<i32>, target: i32) -> Vec<i32> {
        let mut map = HashMap::new();

        for (i, &num) in nums.iter().enumerate() {
            let complement = target - num;

            if let Some(&index) = map.get(&complement) {
                return vec![index as i32, i as i32];
            }

            map.insert(num, i);
        }

        vec![]
    }
}
